function D_Optimal_Test(exampleFile,resultsFolder,runs,n2fi,n3fi,n4fi,ndif,numModels,tolerance,num_tests)

load(exampleFile,'A','Aeq','b','beq','num_factors');
if ~isdir(resultsFolder)
    mkdir(resultsFolder); 
end

for i = 1:length(runs)
    for j = 1:length(n2fi)
        for k = 1:length(n3fi)
            for m = 1:length(n4fi)
                for n = 1:length(ndif)
                    for p = 1:length(numModels)
                        for q = 1:length(tolerance)
                            inputs.runs = runs(i);
                            inputs.n2fi = n2fi(j);
                            inputs.n3fi = n3fi(k);
                            inputs.n4fi = n4fi(m);
                            inputs.ndif = ndif(n);
                            inputs.numModels = numModels(p);
                            inputs.tolerance = tolerance(q);
                            [design,value,model,runtime,failedCount]=MAMSD(num_factors,runs(i),n2fi(j),n3fi(k),n4fi(m),ndif(n),numModels(p),A,b,Aeq,beq,num_tests,tolerance(q));
                            modelSpaceSize = getModelSpaceSize(num_factors,n2fi(j),n3fi(k),n4fi(m),ndif(n));
                            if modelSpaceSize>10000
                                modelSpace = select_models(num_factors,n2fi(j),n3fi(k),n4fi(m),ndif(n),10000);
                            else
                                modelSpace = FullModelSpace(num_factors,n2fi(j),n3fi(k),n4fi(m),ndif(n));
                            end
                            averageDEfficiency = average_efficiency(design,modelSpace,ndif(n));
                            save(fullfile(resultsFolder,['Runs_' num2str(runs(i)) ' n2fi_' num2str(n2fi(j)) ' n3fi_' num2str(n3fi(k))...
                                ' n4fi_' num2str(n4fi(m)) ' ndif_' num2str(ndif(n)) ' numModels_' num2str(numModels(p))]),...
                                'design','value','model','runtime','inputs','failedCount','averageDEfficiency','modelSpace');
                        end
                    end
                end
            end
        end
    end
end

end
