function model=FullModel(numFactors,id)

if strcmp(id,'linear')
    model=eye(numFactors);

elseif strcmp(id,'quadratic')
    n2fi=nchoosek(numFactors,2);
    All2fi=nchoosek(1:numFactors,2);
    blending=zeros(n2fi,numFactors);
    for i=1:n2fi
       blending(i,All2fi(i,:))=1; 
    end    
    model=vertcat(eye(numFactors),blending);
    
elseif strcmp(id,'specialCubic')
    n2fi=nchoosek(numFactors,2);
    All2fi=nchoosek(1:numFactors,2);
    blend2=zeros(n2fi,numFactors);
    for i=1:n2fi
       blend2(i,All2fi(i,:))=1; 
    end   
    
    n3fi=nchoosek(numFactors,3);
    All3fi=nchoosek(1:numFactors,3);
    blend3=zeros(n3fi,numFactors);
    for j=1:n3fi
       blend3(j,All3fi(j,:))=1; 
    end
    model=vertcat(eye(numFactors),blend2,blend3);
    
elseif strcmp(id,'cubic')
    n2fi=nchoosek(numFactors,2);
    All2fi=nchoosek(1:numFactors,2);
    blend2=zeros(n2fi,numFactors);
    for i=1:n2fi
       blend2(i,All2fi(i,:))=1; 
    end   
    
    n3fi=nchoosek(numFactors,3);
    All3fi=nchoosek(1:numFactors,3);
    blend3=zeros(n3fi,numFactors);
    for j=1:n3fi
       blend3(j,All3fi(j,:))=1; 
    end
    
    dif=zeros(2*n2fi,numFactors);
    for k=1:2:2*n2fi
        dif(k,All2fi((k+1)/2,1))=2;
        dif(k,All2fi((k+1)/2,2))=1;
        dif(k+1,All2fi((k+1)/2,1))=1;
        dif(k+1,All2fi((k+1)/2,2))=2;
    end
    model=vertcat(eye(numFactors),blend2,blend3,dif);
end

end