function models=FullModelSpace(numFactors,n2fi,n3fi,n4fi,ndif)

nAll2fi=nchoosek(numFactors,2);
nAll3fi=nchoosek(numFactors,3);
if numFactors>=4
    nAll4fi = nchoosek(numFactors,4);
else
    if n4fi>0
        error('Cannot have 4th order interaction term with fewer than 4 factors.'); 
    end
    nAll4fi = 0; %To maintain count
end
nAllDif=nchoosek(numFactors,2);

numModels=nchoosek(nAll2fi,n2fi)*nchoosek(nAll3fi,n3fi)*nchoosek(nAll4fi,n4fi)*nchoosek(nAll2fi,ndif);
models=zeros(numFactors+n2fi+n3fi+n4fi+2*ndif,numFactors,numModels);

All2fi=nchoosek(1:numFactors,2);
All3fi=nchoosek(1:numFactors,3);
All4fi=nchoosek(1:numFactors,4);
Alldif=nchoosek(1:numFactors,2);

sub2fi=nchoosek(1:nAll2fi,n2fi);
sub3fi=nchoosek(1:nAll3fi,n3fi);
sub4fi=nchoosek(1:nAll4fi,n4fi);
subdif=nchoosek(1:nAllDif,ndif);

n2=[1:n2fi;1:n2fi]';
n3=[1:n3fi;1:n3fi;1:n3fi]';
n4= repmat((1:n4fi)',1,4);
nd = repmat((1:2*ndif)',1,2);
for j=1:numModels
    modelj=zeros(numFactors+n2fi+n3fi+2*ndif,numFactors);
    modelj(1:numFactors,:)=eye(numFactors);
    if n2fi>0
        j2fis=All2fi(sub2fi(mod(j-1,length(sub2fi(:,1)))+1,:),:);
        idx2=n2+(j2fis-1)*n2fi;
        m2fi=zeros(n2fi,numFactors);
        m2fi(idx2)=1;
        modelj(numFactors+1:numFactors+n2fi,:)=m2fi;
    end    
    if n3fi>0
        j3fis=All3fi(sub3fi(mod(j-1,length(sub3fi(:,1)))+1,:),:);
        idx3=n3+(j3fis-1)*n3fi;
        m3fi=zeros(n3fi,numFactors);
        m3fi(idx3)=1;
        modelj(numFactors+n2fi+1:numFactors+n2fi+n3fi,:)=m3fi;
    end
    if n4fi > 0
        j4fis=All4fi(sub4fi(mod(j-1,length(sub4fi(:,1)))+1,:),:);
        idx4=n4+(j4fis-1)*n4fi;
        m4fi=zeros(n4fi,numFactors);
        m4fi(idx4)=1;
        modelj(numFactors+n2fi+n3fi+1:numFactors+n2fi+n3fi+n4fi,:)=m4fi;
    end
    if ndif > 0
        jdifs = sortrows(repmat(Alldif(subdif(mod(j-1,length(subdif(:,1)))+1,:),:),2,1));
        idxdif = nd + (jdifs-1)*2*ndif;
        idxdif = idxdif';
        mdif = zeros(2*ndif,numFactors);
        mdif(idxdif(:)) = repmat([1;2;2;1],ndif,1);
        modelj(numFactors+n2fi+n3fi+n4fi+1:numFactors+n2fi+n3fi+n4fi+2*ndif,:)=mdif;
    end
    models(:,:,j)=modelj;
end
end