function [avg,estimationCapacity] = average_efficiency(design,models,ndif)
effs=zeros(length(models(1,1,:)),1);
runs=length(design(:,1));
parameters=length(models(:,1,1));
estimable = false(size(models,3),1);
for i=1:length(models(1,1,:))
    xd = expandDesign(design,models(:,:,i),ndif);
    infoMatrix = xd'*xd;
    c = rcond(infoMatrix);
    if c > 1e-14
        estimable(i) = true;
        effs(i) = (100/runs)*(det(infoMatrix)^(1/parameters));
    else
        effs(i) = 0;
    end
%     effs(i)=(100/runs)*(det(expandDesign(design,models(:,:,i),ndif)'*expandDesign(design,models(:,:,i),ndif))^(1/parameters));
end
avg=mean(effs);
estimationCapacity = sum(estimable)/length(estimable);
end