function X=diff_x2fx(A,model,num_difference)

%Performs the x2fx function for models that include difference terms such
%as x1^2*x2-x1*x2^2. The difference terms must be the last in the matrix
%model, with each row corresponding to one part of the difference. Two
%terms from a difference must be given successively in model.
%Num_difference is the number of difference terms, not the number of rows
%for difference terms model.

D=myx2fx(A,model(end-(2*num_difference-1):end,:)); %calculate x2fx for just the terms in the differences
dif=diff(fliplr(D),1,2);%calculates the differences between all columns
dif=fliplr(dif); %flip back to the originial order
dif(:,2:2:end)=[]; %eliminate the unneeded columns calculated by diff function
                   %leaves just the x1^2*x2-x1*x2^2,... terms
X=myx2fx(A,model(1:end-2*num_difference,:)); %use standard x2fx on the standard model term types
X=horzcat(X,dif); %combine the normal term columns and the difference term columns

end