function [avg,estCapacity]=mean_avp(design,models,A,b,Aeq,beq,num_factors,ndif)

numModels=length(models(1,1,:));
avps=zeros(numModels,1);
estimable = false(numModels,1);
volume=mixture_volume(A,b,Aeq,beq,num_factors);
moments=zeros(length(models(:,1)),length(models(:,1)),numModels);
sample=rejection_sampling(5000,num_factors,A,b);
for j=1:numModels
   moments(:,:,j)=momOneSample(models(:,:,j),volume,sample,ndif); 
end
for i=1:numModels
    D = expandDesign(design,models(:,:,i),ndif);
    infoMatrix = D'*D;
    c = rcond(infoMatrix);
    if c > 1e-14
        estimable(i) = true;
        avps(i) = trace(infoMatrix\moments(:,:,i))/volume;
    else
        disp(trace(infoMatrix\moments(:,:,i))/volume)
    end
%   avps(i)=trace((D'*D)\moments(:,:,i))/volume;
end

% avg=mean(avps);
avg = mean(avps(estimable));
estCapacity = sum(estimable)/numModels;
end