function [objective,gradient]=mixture_d_objective(current_row,model,settings,row,ndif)
    settings(row,:)=current_row;
    numModel=length(model(1,1,:));
    objective=zeros(1,numModel);
    
    num_cont=length(current_row);
    numModel=length(model(1,1,:));
    grads=zeros(numModel,num_cont);
    
    for k=1:numModel
        current=expandDesign(settings,model(:,:,k),ndif);
        objective(k) = -log(prod(svd(current)));
        %objective(k)=-log(det(current'*current));
        gradient=zeros(1,num_cont);
        fixedProd = -2.*current(row,:)/(current'*current);
        for n=1:num_cont
            tmp = model(:,:,k);
            tmp(:,n) = tmp(:,n)-1;
            const = ones(length(model(:,n,k)),1);
            const(n) = model(n,n,k);
            derivative = const.*prod(bsxfun(@power,settings(row,:),tmp),2);
%             derivative = const.*prod(settings(row,:).^tmp,2);
            derivative(model(:,n,k)<=0) = 0;
%             test = derivative;

%             derivative=ones(length(current(row,:)),1);
%             for m=1:length(model(:,n,k))-2*ndif
%                 if model(m,n,k)>0
%                     if m==n
%                         derivative(m)=derivative(m)*model(m,m,k)*settings(row,n)^(model(m,m,k)-1);
%                     else
%                         for i=1:length(model(1,:,k))
%                             if i==n
%                                 derivative(m)=derivative(m)*settings(row,i)^(model(m,i,k)-1);
%                             else
%                                 derivative(m)=derivative(m)*settings(row,i)^model(m,i,k);
%                             end
%                         end
%                     end
%                 else
%                     derivative(m)=0;
%                 end
%             end
            count=1;
            for m=(length(model(:,n,k))-(2*ndif-1)):2:length(model(:,n,k))
                term1=model(m,:,k).*settings(row,:);
                term1=prod(term1(find(term1)));
                term2=settings(row,(model(m+1,:,k)==2))^2;
                derivative(end-ndif+count)=term1-term2;
                count=count+1;
            end
%             if ~isequal(derivative,test)
%                 error('Failed'); 
%             end
            gradient(n)=fixedProd*derivative;
        end
        grads(k,:)=gradient;
    end
    objective=mean(objective);
    gradient=(1/numModel).*sum(grads,1); 
%     gradient=grad(row,model,current_row,settings,ndif);

end