function integral=moments_dif(A,b,Aeq,beq,model,volume,num_factors,ndif)
%Estimates the moments matrix M which is the integral of f(x)*f(x)' over
%the experimental region where f is the model function that expands the
%design. A Monte Carlo integration is used. 

N=1000;
sample=rejection_sampling(N,num_factors,A,b);
f=expandDesign(sample,model,ndif);
values = f'*f;
integral = (volume/N).*values;
end