function [c,iter]=multivariate_bisection(f,a,b,tol,N)
%Given a feasible point x and a direction d, find the maximum scalar c such that
%x+cd is feasible. Starts with initial interval [a,b] and continues cutting
%the interval in half until within a specified tolerance of the maximum c.
c=(a+b).*.5;
err=abs(a-b).*.5;
iter=0;

    while (err>tol)&&(iter<=N)
        fc=f(c);
        if ~any(fc>0)
            if fc==0
                break
            else
            a=c;
            end
        else
            b=c;
        end
       iter=iter+1;
       c=(a+b)*.5;
       err=abs(b-a)*.5;
    end
    if any(fc>b)
          c=a;       
    end

end