function final_design = rejection_sampling(num_runs, num_factors, A, b)
    
    final_design = nan(num_runs, num_factors);

    while(any(any(isnan(final_design))))
        seeds = rand(num_runs, num_factors-1);
        design = zeros(num_runs, num_factors);

        upperbound = b(2:2:2*num_factors);
        lowerbound = -1*b(1:2:2*num_factors-1);

        delta = ones(num_runs,1);
        for k = num_factors:-1:2
            d = max(lowerbound(k)./delta, 1-(sum(upperbound(1:k-1))./delta));
            phi = min(upperbound(k)./delta, 1-(sum(lowerbound(1:k-1))./delta));
            design(:,k) =  G(seeds(:,k-1),d,phi,delta,k-1);
            delta = 1 - sum(design(:,k:end),2);
        end
        design(:,1) = 1 - sum(design(:,2:end),2);
        
        isvalid = all(A*design'<=b);
        firstnan = find(any(isnan(final_design),2),1);
        countvalid = sum(isvalid);
        if firstnan+countvalid-1 <= num_runs
            final_design(firstnan:firstnan+countvalid-1,:) = design(isvalid,:); 
        else
            final_design(firstnan:end,:) = design(find(isvalid,num_runs-firstnan+1),:);
        end
    end
    
end

function a = G(u,d,phi,delta,k)
    a = delta.*(1-(u.*(1-phi).^k+(1-u).*(1-d).^k).^(1/k));
end